/*
    Escuela Didáctica S.A.S 
    Atributos de los enlaces
    
    data-openin => los posible valores son: _modal, _self, _blank
    
    data-href => URL que se abrirá 
    
    Cuando sea un enlace en el atributo debe llevar el siguiente valor href="javascript:void(0);"
    
    Ejemplos de enlaces o botones personalizados:
    <a href="javascript:void(0);" data-href="https://johnguerra.co/coronavirus" data-openin="_modal">Lección 1</a>
    <a href="javascript:void(0);" data-href="https://johnguerra.co/coronavirus" data-openin="_self">Lección 1</a>
    <a href="javascript:void(0);" data-href="https://johnguerra.co/coronavirus" data-openin="_blank">Lección 1</a>
*/

//Variables
var attrDataHref = "[data-href]";
var clasebtnCloseModal = "mcModal__close";
var idModalIfram = "mcModal__iframe";

document.addEventListener("DOMContentLoaded", initOpenIn);

//funcion responsable de activar los eventos
function initOpenIn() {
    try {
        var itemDataHref = document.querySelectorAll(attrDataHref); //enlaces con data-href
        var btnCloseModal = document.getElementsByClassName(clasebtnCloseModal); //boton cerrar modal
        //eventos
        if (itemDataHref) {
            mcAddEventClick(itemDataHref, mcOpeninDataHref); //clic en enlace data-href
        }
        if (btnCloseModal) {
            mcAddEventClick(btnCloseModal, mcCloseModal); //clic en cerar modal
        }
    } catch (e) {
        console.log(e);
    }
}

//funcion responsable de enlazar eventos
function mcAddEventClick(element, functions) {
    for (let i = 0; i < element.length; i++) {
        element[i].addEventListener("click", functions);
    }
}

//funcion responsable de abrir URL 
function mcOpeninDataHref() {
    var openIn = this.getAttribute("data-openin");
    var url = this.getAttribute("data-href");
    var elemento = this;
    //console.log('url href: ', url);
    if (url) {
        mcOpenInto(elemento, url, openIn);
    } else {
        console.log('No se encontró la url');
    }
}

//funcion responsable de abrir la URL en metodo correspondiente
function mcOpenInto(elemento, url, openIn) {
    switch (openIn) {
        case '_modal':
            mcOpenintoModal(url);
            break;
        case '_self':
            mcOpeninSelf(elemento, url);
            break;
        case '_blank':
            mcOpeninBlank(elemento, url);
            break;
    }
}

//funcion responsable de abrir la url en el modal
function mcOpenintoModal(url) {
    var body = document.getElementsByTagName('body');
    document.getElementById(idModalIfram).setAttribute("src", url);
    document.getElementById('mcModal').classList.add('mcModal--active');
    Object.entries(body).forEach(([i, value]) => {
        value.style.overflow = 'hidden';
    });
}

//funcion responsable de abrir el enlace en la misma ventana
function mcOpeninSelf(elem, url) {
    if (elem.tagName == 'a') {
        elem.setAttribute("target", "_self");
        elem.setAttribute("href", url);
    } else {
        document.location.href = url;
    }
}

//funcion responsable de abrir el enlace en una ventana nueva
function mcOpeninBlank(elem, url) {
    if (elem.tagName == 'a') {
        elem.setAttribute("target", "_blank");
        elem.setAttribute("href", href);
    } else {
        window.open(url);
    }
}

//Función responsable de cerrar el modal
function mcCloseModal() {
    var body = document.getElementsByTagName('body');
    document.getElementById('mcModal').classList.remove('mcModal--active');
    Object.entries(body).forEach(([i, value]) => {
        value.style.overflow = 'initial';
    });
}