function setScrollAnimations(elem) {
    // i: Cantidad de elementos visibles en pantalla al cargar 
    let i = 5;

    switch (elem.getAttribute('data-vuacontenido')) {
        /** Si en un tema es necesario cambiar i usar:
         * case '(numero del tema)':
         * i = (numero de elemtos)
         * break;
         */
    }

    const screen = elem.offsetHeight;
    const sections = elem.querySelectorAll("[data-settings*='animation']");

    for (let j = 0; j < i; j++) {
        animate(sections[j]);
    }

    elem.addEventListener('scroll', function() {
        for (let j = i; j < sections.length; j++) {
            let position = sections[j].getBoundingClientRect().top;
            if (position < screen) {
                animate(sections[j]);
            }
        }
    })
}

function animate(elem) {
    const settings = elem.getAttribute('data-settings');
    const animation = JSON.parse(settings);
    elem.style.animationName = animation.animation;
    elem.style.animationDuration = "1.25s";
    elem.style.animationFillMode = "forwards";
}

function removeAnimatedClass() {
    let elementsWithAnimations = document.querySelectorAll("[data-settings*='animation']");
    elementsWithAnimations.forEach((value) => {
        let dataSettings = value.getAttribute("data-settings");
        let animationJSON = JSON.parse(dataSettings);

        value.classList.remove(animationJSON.animation);
        value.classList.remove('animated');
    });
}

document.addEventListener('DOMContentLoaded', function() {
    setScrollAnimations(document.getElementById('vuaMenu-tema1'));
})